# #Eligibility
#
# Reference for developers
#
# OpenAPI spec version: v3
#
# Generated by: https://github.com/swagger-api/swagger-codegen.git
# Swagger Codegen version: 2.4.17
#

require 'date'

module ChangeHealthcare
  module Eligibility
    module SwaggerClient
      # Loop: 2110[C|D], Notes: Eligibility or Benefit Information, EQ02 and beyond only
      class MedicalProcedure
        # Loop: 2110[C|D], Segment: EQ, Element: EQ05, Notes: Composite Diagnosis Code Pointer
        attr_accessor :diagnosis_code_pointer

        # Loop: 2110[C|D], Segment: EQ, Element: EQ02-2, Notes: Composite Medical Procedure Identifier - Procedure Code
        attr_accessor :procedure_code

        # Loop: 2110[C|D], Segment: EQ, Element: EQ02-3, Notes: Composite Medical Procedure Identifier - Procedure Modifier
        attr_accessor :procedure_modifiers

        # Loop: 2110[C|D], Segment: EQ, Element: EQ02-1, Notes: Composite Medical Procedure Identifier - Product or Service ID Qualifier, Allowed Values are: 'AD' American Dental Association Codes, 'CJ' Current Procedural Terminology (CPT) Codes,'HC' Health Care Financing Administration Common Procedural Coding System (HCPCS) Codes,'ID' International Classification of Diseases, 9th Revision, Clinical Modification (ICD-9-CM) - Procedure, 'IV' Home Infusion EDI Coalition (HIEC) Product/Service Code, 'N4' National Drug Code in 5-4-2 Format, 'ZZ' Mutually Defined
        attr_accessor :product_or_service_id_qualifier

        class EnumAttributeValidator
          attr_reader :datatype, :allowable_values

          def initialize(datatype, allowable_values)
            @allowable_values = allowable_values.map do |value|
              case datatype.to_s
              when /Integer/i
                value.to_i
              when /Float/i
                value.to_f
              else
                value
              end
            end
          end

          def valid?(value)
            !value || allowable_values.include?(value)
          end
        end

        # Attribute mapping from ruby-style variable name to JSON key.
        def self.attribute_map
          {
            'diagnosis_code_pointer': :diagnosisCodePointer,
            'procedure_code': :procedureCode,
            'procedure_modifiers': :procedureModifiers,
            'product_or_service_id_qualifier': :productOrServiceIDQualifier
          }
        end

        # Attribute type mapping.
        def self.swagger_types
          {
            'diagnosis_code_pointer': :'Array<String>',
            'procedure_code': :String,
            'procedure_modifiers': :'Array<String>',
            'product_or_service_id_qualifier': :String
          }
        end

        # Initializes the object
        # @param [Hash] attributes Model attributes in the form of hash
        def initialize(attributes = {})
          return unless attributes.is_a?(Hash)

          # convert string to symbol for hash key
          attributes = attributes.transform_keys(&:to_sym)

          if attributes.key?(:diagnosisCodePointer)
            if (value = attributes[:diagnosisCodePointer]).is_a?(Array)
              self.diagnosis_code_pointer = value
            end
          end

          self.procedure_code = attributes[:procedureCode] if attributes.key?(:procedureCode)

          if attributes.key?(:procedureModifiers)
            if (value = attributes[:procedureModifiers]).is_a?(Array)
              self.procedure_modifiers = value
            end
          end

          self.product_or_service_id_qualifier = attributes[:productOrServiceIDQualifier] if attributes.key?(:productOrServiceIDQualifier)
        end

        # Show invalid properties with the reasons. Usually used together with valid?
        # @return Array for valid properties with the reasons
        def list_invalid_properties
          []
        end

        # Check to see if the all the properties in the model are valid
        # @return true if the model is valid
        def valid?
          product_or_service_id_qualifier_validator = EnumAttributeValidator.new('String', %w[AD CJ HC ID IV N4 ZZ])
          return false unless product_or_service_id_qualifier_validator.valid?(@product_or_service_id_qualifier)

          true
        end

        # Custom attribute writer method checking allowed values (enum).
        # @param [Object] product_or_service_id_qualifier Object to be assigned
        def product_or_service_id_qualifier=(product_or_service_id_qualifier)
          validator = EnumAttributeValidator.new('String', %w[AD CJ HC ID IV N4 ZZ])
          unless validator.valid?(product_or_service_id_qualifier)
            raise ArgumentError, %(invalid value for "product_or_service_id_qualifier", must be one of #{validator.allowable_values}.)
          end

          @product_or_service_id_qualifier = product_or_service_id_qualifier
        end

        # Checks equality by comparing each attribute.
        # @param [Object] Object to be compared
        def ==(o)
          return true if equal?(o)

          self.class == o.class &&
            diagnosis_code_pointer == o.diagnosis_code_pointer &&
            procedure_code == o.procedure_code &&
            procedure_modifiers == o.procedure_modifiers &&
            product_or_service_id_qualifier == o.product_or_service_id_qualifier
        end

        # @see the `==` method
        # @param [Object] Object to be compared
        def eql?(o)
          self == o
        end

        # Calculates hash code according to all attributes.
        # @return [Fixnum] Hash code
        def hash
          [diagnosis_code_pointer, procedure_code, procedure_modifiers, product_or_service_id_qualifier].hash
        end

        # Builds the object from hash
        # @param [Hash] attributes Model attributes in the form of hash
        # @return [Object] Returns the model itself
        def build_from_hash(attributes)
          return nil unless attributes.is_a?(Hash)

          self.class.swagger_types.each_pair do |key, type|
            if type =~ /\AArray<(.*)>/i
              # check to ensure the input is an array given that the attribute
              # is documented as an array but the input is not
              if attributes[self.class.attribute_map[key]].is_a?(Array)
                send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize(Regexp.last_match(1), v) })
              end
            elsif !attributes[self.class.attribute_map[key]].nil?
              send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
            end # or else data not found in attributes(hash), not an issue as the data can be optional
          end

          self
        end

        # Deserializes the data based on type
        # @param string type Data type
        # @param string value Value to be deserialized
        # @return [Object] Deserialized data
        def _deserialize(type, value)
          case type.to_sym
          when :DateTime
            DateTime.parse(value)
          when :Date
            Date.parse(value)
          when :String
            value.to_s
          when :Integer
            value.to_i
          when :Float
            value.to_f
          when :BOOLEAN
            if value.to_s =~ /\A(true|t|yes|y|1)\z/i
              true
            else
              false
            end
          when :Object
            # generic object (usually a Hash), return directly
            value
          when /\AArray<(?<inner_type>.+)>\z/
            inner_type = Regexp.last_match[:inner_type]
            value.map { |v| _deserialize(inner_type, v) }
          when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
            k_type = Regexp.last_match[:k_type]
            v_type = Regexp.last_match[:v_type]
            {}.tap do |hash|
              value.each do |k, v|
                hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
              end
            end
          else # model
            temp_model = SwaggerClient.const_get(type).new
            temp_model.build_from_hash(value)
          end
        end

        # Returns the string representation of the object
        # @return [String] String presentation of the object
        def to_s
          to_hash.to_s
        end

        # to_body is an alias to to_hash (backward compatibility)
        # @return [Hash] Returns the object in the form of hash
        def to_body
          to_hash
        end

        # Returns the object in the form of hash
        # @return [Hash] Returns the object in the form of hash
        def to_hash
          hash = {}
          self.class.attribute_map.each_pair do |attr, param|
            value = send(attr)
            next if value.nil?

            hash[param] = _to_hash(value)
          end
          hash
        end

        # Outputs non-array value in the form of hash
        # For object, use to_hash. Otherwise, just return the value
        # @param [Object] value Any valid value
        # @return [Hash] Returns the value in the form of hash
        def _to_hash(value)
          if value.is_a?(Array)
            value.compact.map { |v| _to_hash(v) }
          elsif value.is_a?(Hash)
            {}.tap do |hash|
              value.each { |k, v| hash[k] = _to_hash(v) }
            end
          elsif value.respond_to? :to_hash
            value.to_hash
          else
            value
          end
        end
      end
    end
  end
end
