# #Eligibility
#
# Reference for developers
#
# OpenAPI spec version: v3
#
# Generated by: https://github.com/swagger-api/swagger-codegen.git
# Swagger Codegen version: 2.4.17
#

require 'date'

module ChangeHealthcare
  module Eligibility
    module SwaggerClient
      # Loop: 2100B, Segment: NM1, Notes: Information Receiver
      class Provider
        # Loop: 2100B Segment: MN1, Element: NM104, Notes: NM101=PR when providerType='payer' && payerId is present otherwise 1P for Provider, NM102=1 Person, firstName 1-35 alphanumberic characters
        attr_accessor :first_name

        # Loop: 2100B Segment: MN1, Element: NM103, Notes: NM101=PR when providerType='payer' && payerId is present otherwise 1P for Provider, NM102=1 Person, lastName 1-60 alphanumberic characters
        attr_accessor :last_name

        attr_accessor :name, :person

        # Loop: 2100B Segment: MN1, Element: NM109, Notes: NM108=XX Centers for Medicare and Medicaid Services National Provider Identifier 2-80 alphanumberic characters
        attr_accessor :npi

        # Loop: 2100B Segment: MN1, Element: NM103, Notes: NM101=PR when providerType='payer' && payerId is present otherwise 1P for Provider, NM102=2 Non-Person Entity, organizationName 1-60 alphanumberic characters
        attr_accessor :organization_name

        # Loop: 2100B Segment: MN1, Element: NM109, Notes: NM101=PR when providerType='payer' && payerId is present otherwise 1P for Provider, NM108=PI Payor Identification 2-80 alphanumberic characters
        attr_accessor :payor_id

        # Loop: 2100B Segment: PRV, Element: PRV01, Notes: PRV02=PXC Allowed Values are: 'AD' Admitting, 'AT' Attending, 'BI' Billing, 'CO' Consulting, 'CV' Covering, 'H' Hospital, 'HH' Home Health Care, 'LA' Laboratory, 'OT' Other Physician, 'P1' Pharmacist, 'P2' Pharmacy, 'PC' Primary Care Physician, 'PE' Performing, 'R' Rural Health Clinic, 'RF' Referring, 'SB' Submitting, 'SK' Skilled Nursing Facility, 'SU' Supervising
        attr_accessor :provider_code

        # Loop: 2100B Segment: MN1, Notes: NM101=PR when providerType='payer' && payerId is present otherwise 1P for Provider
        attr_accessor :provider_type

        # Loop: 2100B Segment: PRV, Element: PRV03, Notes: PRV02=PXC referenceIdentification and controlNumber into PRV03
        attr_accessor :reference_identification

        # Loop: 2100B Segment: MN1, Element: NM109, Notes: NM108=SV Service Provider Number 2-80 alphanumberic characters
        attr_accessor :service_provider_number

        # Loop: 2100B Segment: MN1, Element: NM109, Notes: NM108=FI Federal Taxpayer’s Identification Number 2-80 alphanumberic characters
        attr_accessor :tax_id

        class EnumAttributeValidator
          attr_reader :datatype, :allowable_values

          def initialize(datatype, allowable_values)
            @allowable_values = allowable_values.map do |value|
              case datatype.to_s
              when /Integer/i
                value.to_i
              when /Float/i
                value.to_f
              else
                value
              end
            end
          end

          def valid?(value)
            !value || allowable_values.include?(value)
          end
        end

        # Attribute mapping from ruby-style variable name to JSON key.
        def self.attribute_map
          {
            'first_name': :firstName,
            'last_name': :lastName,
            'name': :name,
            'npi': :npi,
            'organization_name': :organizationName,
            'payor_id': :payorId,
            'person': :person,
            'provider_code': :providerCode,
            'provider_type': :providerType,
            'reference_identification': :referenceIdentification,
            'service_provider_number': :serviceProviderNumber,
            'tax_id': :taxId
          }
        end

        # Attribute type mapping.
        def self.swagger_types
          {
            'first_name': :String,
            'last_name': :String,
            'name': :BOOLEAN,
            'npi': :String,
            'organization_name': :String,
            'payor_id': :String,
            'person': :BOOLEAN,
            'provider_code': :String,
            'provider_type': :String,
            'reference_identification': :String,
            'service_provider_number': :String,
            'tax_id': :String
          }
        end

        # Initializes the object
        # @param [Hash] attributes Model attributes in the form of hash
        def initialize(attributes = {})
          return unless attributes.is_a?(Hash)

          # convert string to symbol for hash key
          attributes = attributes.transform_keys(&:to_sym)

          self.first_name = attributes[:firstName] if attributes.key?(:firstName)

          self.last_name = attributes[:lastName] if attributes.key?(:lastName)

          self.name = attributes[:name] if attributes.key?(:name)

          self.npi = attributes[:npi] if attributes.key?(:npi)

          self.organization_name = attributes[:organizationName] if attributes.key?(:organizationName)

          self.payor_id = attributes[:payorId] if attributes.key?(:payorId)

          self.person = attributes[:person] if attributes.key?(:person)

          self.provider_code = attributes[:providerCode] if attributes.key?(:providerCode)

          self.provider_type = attributes[:providerType] if attributes.key?(:providerType)

          self.reference_identification = attributes[:referenceIdentification] if attributes.key?(:referenceIdentification)

          self.service_provider_number = attributes[:serviceProviderNumber] if attributes.key?(:serviceProviderNumber)

          self.tax_id = attributes[:taxId] if attributes.key?(:taxId)
        end

        # Show invalid properties with the reasons. Usually used together with valid?
        # @return Array for valid properties with the reasons
        def list_invalid_properties
          []
        end

        # Check to see if the all the properties in the model are valid
        # @return true if the model is valid
        def valid?
          provider_code_validator = EnumAttributeValidator.new('String', %w[AD AT BI CO CV H HH LA OT P1 P2 PC PE R RF SB SK SU])
          return false unless provider_code_validator.valid?(@provider_code)

          true
        end

        # Custom attribute writer method checking allowed values (enum).
        # @param [Object] provider_code Object to be assigned
        def provider_code=(provider_code)
          validator = EnumAttributeValidator.new('String', %w[AD AT BI CO CV H HH LA OT P1 P2 PC PE R RF SB SK SU])
          raise ArgumentError, %(invalid value for "provider_code", must be one of #{validator.allowable_values}.) unless validator.valid?(provider_code)

          @provider_code = provider_code
        end

        # Checks equality by comparing each attribute.
        # @param [Object] Object to be compared
        def ==(o)
          return true if equal?(o)

          self.class == o.class &&
            first_name == o.first_name &&
            last_name == o.last_name &&
            name == o.name &&
            npi == o.npi &&
            organization_name == o.organization_name &&
            payor_id == o.payor_id &&
            person == o.person &&
            provider_code == o.provider_code &&
            provider_type == o.provider_type &&
            reference_identification == o.reference_identification &&
            service_provider_number == o.service_provider_number &&
            tax_id == o.tax_id
        end

        # @see the `==` method
        # @param [Object] Object to be compared
        def eql?(o)
          self == o
        end

        # Calculates hash code according to all attributes.
        # @return [Fixnum] Hash code
        def hash
          [first_name, last_name, name, npi, organization_name, payor_id, person, provider_code, provider_type, reference_identification, service_provider_number, tax_id].hash
        end

        # Builds the object from hash
        # @param [Hash] attributes Model attributes in the form of hash
        # @return [Object] Returns the model itself
        def build_from_hash(attributes)
          return nil unless attributes.is_a?(Hash)

          self.class.swagger_types.each_pair do |key, type|
            if type =~ /\AArray<(.*)>/i
              # check to ensure the input is an array given that the attribute
              # is documented as an array but the input is not
              if attributes[self.class.attribute_map[key]].is_a?(Array)
                send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize(Regexp.last_match(1), v) })
              end
            elsif !attributes[self.class.attribute_map[key]].nil?
              send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
            end # or else data not found in attributes(hash), not an issue as the data can be optional
          end

          self
        end

        # Deserializes the data based on type
        # @param string type Data type
        # @param string value Value to be deserialized
        # @return [Object] Deserialized data
        def _deserialize(type, value)
          case type.to_sym
          when :DateTime
            DateTime.parse(value)
          when :Date
            Date.parse(value)
          when :String
            value.to_s
          when :Integer
            value.to_i
          when :Float
            value.to_f
          when :BOOLEAN
            if value.to_s =~ /\A(true|t|yes|y|1)\z/i
              true
            else
              false
            end
          when :Object
            # generic object (usually a Hash), return directly
            value
          when /\AArray<(?<inner_type>.+)>\z/
            inner_type = Regexp.last_match[:inner_type]
            value.map { |v| _deserialize(inner_type, v) }
          when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
            k_type = Regexp.last_match[:k_type]
            v_type = Regexp.last_match[:v_type]
            {}.tap do |hash|
              value.each do |k, v|
                hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
              end
            end
          else # model
            temp_model = SwaggerClient.const_get(type).new
            temp_model.build_from_hash(value)
          end
        end

        # Returns the string representation of the object
        # @return [String] String presentation of the object
        def to_s
          to_hash.to_s
        end

        # to_body is an alias to to_hash (backward compatibility)
        # @return [Hash] Returns the object in the form of hash
        def to_body
          to_hash
        end

        # Returns the object in the form of hash
        # @return [Hash] Returns the object in the form of hash
        def to_hash
          hash = {}
          self.class.attribute_map.each_pair do |attr, param|
            value = send(attr)
            next if value.nil?

            hash[param] = _to_hash(value)
          end
          hash
        end

        # Outputs non-array value in the form of hash
        # For object, use to_hash. Otherwise, just return the value
        # @param [Object] value Any valid value
        # @return [Hash] Returns the value in the form of hash
        def _to_hash(value)
          if value.is_a?(Array)
            value.compact.map { |v| _to_hash(v) }
          elsif value.is_a?(Hash)
            {}.tap do |hash|
              value.each { |k, v| hash[k] = _to_hash(v) }
            end
          elsif value.respond_to? :to_hash
            value.to_hash
          else
            value
          end
        end
      end
    end
  end
end
